	.486
	OPTION	SEGMENT:USE16
	.DOSSEG
__CKCM__ = 1
	INCLUDE <./../include/keen1.inc>
	

CSEG SEGMENT PARA USE16 'CODE'
	start:
	INCLUDE <./../include/k1cseg.asm>
CSEG ENDS
	


ATRSEG	SEGMENT	PARA USE16
	ASSUME	cs:ATRSEG, ds:dseg, ss:dseg, es:nothing

	public CM_check_ground
CM_check_ground	PROC	Far

blockingreturn	=	-2
old_box_top_y	=	-6		;dword
old_box_top_y_T 	=	-8
new_box_top_y_T	=	-10
old_box_bot_y	=	-14		; dword
old_box_bot_y_T	=	-16
new_box_bot_y_T	=	-18
box_left_x_T	=	-20
box_right_x_T	=	-22
midpoint_x	=	-26		;dword
midpoint_x_T	=	-28
bottomtile	=	-56		; +1 if standing on slope, -1 if on normal, and 0 if not standing on anything 

	push	bp
	mov	bp, sp
	sub	sp, 60
	push	si
	push	di
	xor	ax, ax
	mov	[bp+blockingreturn], ax
	mov	[bp+bottomtile], ax

;==============================================================================================================
; PART 0 - SET BOUNDARIES 
;==============================================================================================================	

	; limit sprite movement to 15 pixels
	mov ax, temp_sprite.delY
	cmp ax, 0F00h
	jl setb1
	mov word ptr temp_sprite.delY, 0F00h
	jmp setb2
	
setb1:
	cmp ax, -0F00h
	jg setb2
	mov word ptr temp_sprite.delY, -0F00h
	
setb2:
	mov	ax, temp_sprite.delX
	cmp ax, 0F00h
	jl setb3
	mov word ptr temp_sprite.delX, 0F00h
	jmp MoveVert
	
setb3:
	cmp ax, -0F00h
	jg MoveVert
	mov word ptr temp_sprite.delX, -0F00h
	
	
;==============================================================================================================
; PART I - CORRECT Y
;==============================================================================================================	

MoveVert:
	
	movsx	ebx, word ptr temp_sprite.delY	; bx = temp_sprite.delY
	
	mov	eax, temp_sprite.boxY1		; temp_sprite.boxY1 += temp_sprite.delY
	mov	[bp+old_box_top_y], eax
	mov	ecx, eax
	shr	ecx, 12
	mov	[bp+old_box_top_y_T], cx	;TILE(OLD temp_sprite.boxY1)
	add	eax, ebx              	          	
	mov	temp_sprite.boxY1, eax                
	shr	eax, 12
	mov	[bp+new_box_top_y_T], ax	;TILE(NEW temp_sprite.boxY1)
	
	mov 	eax, temp_sprite.boxY2		; temp_sprite.boxY2 += temp_sprite.delY            	
	mov	[bp+old_box_bot_y], eax
	mov	ecx, eax
	shr	ecx, 12
	mov	[bp+old_box_bot_y_T], cx	;TILE(OLD temp_sprite.boxY2)
	add 	eax, ebx                	        	
	mov 	temp_sprite.boxY2, eax                
	shr	eax, 12
	mov	[bp+new_box_bot_y_T], ax	;TILE(NEW temp_sprite.boxY2)
	                                        
	mov	eax, temp_sprite.boxX1		 ;TILE(temp_sprite.boxX1)	
	mov	ecx, eax
	shr	eax, 12			                
	mov	[bp+box_left_x_T], ax                    
	
	mov	eax, temp_sprite.boxX2		;TILE(temp_sprite.boxX2)              
	add	ecx, eax		; ecx = box _leftx + _rightx
	shr	eax, 12                         
	mov	[bp+box_right_x_T], ax                                           
	mov	eax,ecx
	shr	eax, 1		; average (\= 2)
	mov	[bp+midpoint_x], eax	;bp-26 = midpoint_x
	shr	eax, 12
	mov	[bp+midpoint_x_T], ax	;bp-28 = tile(midpoint_x)
	
	cmp 	bx, 0				            
	je	MoveHorz		;if temp_sprite.delY = 0, goto MOVE_HORZ                
	jl	MoveUp		;if temp_sprite.delY<0, goto MOVE_UP

MoveDown:
DownOldSlope:				;1. check if origin tile is slope blocking up
				;by determining if movement intersects with slope

	mov	cx, [bp+midpoint_x_T]	;get tileinfo for  origin tile
	mov	ax, [bp+old_box_bot_y_T]
	mov	dx, 0		;blocking up plane,
	call	GetTileInfo		;ax = info
	
	test	al, 80h		;bit7 = sloped bit
	jz	DownNewNormal	;if not then continue
	
	mov	si, ax		; si = slopeinfo
	xor	edx, edx
	mov	dx, [bp+old_box_bot_y_T]	
	shl	edx, 12		; edx = b_map
	mov	eax, [bp+midpoint_x]
	Call	SlopeIntVert		; return, eax = y_int 

	cmp	eax, [bp+old_box_bot_y]	; y1
	jle	DownNewNormal
	cmp	eax, temp_sprite.boxY2		; y2 (>y1 if moving down)
	jg	DownNewNormal	; jump to DNN if y_int not inside boundary y coords
	
	
	sub	eax, temp_sprite.boxY2		;corr = dest - src = y_int - y_new
	dec	eax		;adjust by one (make correction one more negative to sit atop slope)
	inc	word ptr [bp+bottomtile]	; bottom tile = 1 (sloped)

	jmp	AdjustYDown	

DownNewNormal:			;2 Check if crossing into new tile, and if it is blocking

	mov	ax, [bp+new_box_bot_y_T]
	cmp	ax, [bp+old_box_bot_y_T]
	je	MoveHorz		;If not crossing, then done and move to horz
	
	;FIX.  If midpoint is above a slope tile, and box_left or box_right is above a normal tile, 
	; then still want sprite to land on slope.  Therefore, check tile below midpoint x  before doing normal check
	mov	cx, [bp+midpoint_x_T]
	xor	dx, dx
	call	GetTileInfo		; up blocking plane of tile below mid x, box bot y
	test	al, 80h
	jnz	DownNewSlope
	
	
	mov	di, [bp+box_left_x_T]
DNNLoop:				; loop through range of x coords representing tiles spanned by sprite 
	cmp	di, [bp+box_right_x_T]
	jg	DownNewSlope		; no blocking, have to check slope
	
	mov	ax, [bp+new_box_bot_y_T]	; get blocking up for tile(x,new box bot y)
	mov	cx, di
	xor	dx, dx
	call	GetTileInfo

	test	al, 80h		; if slope, then skip normal correction
	jnz	DNNLoopC
	test	al, 3		; 01, 02, 03 are normal blocking 00 is not
	jz	DNNLoopC		; if tile != 0  then correct and tohorz
	
	mov	ax, word ptr temp_sprite.boxY2				
	inc	ax
	and	ax, 0FFFh
	neg	ax
	cwde
	dec	word ptr [bp+bottomtile]
	jmp	AdjustYDown

	

DNNLoopC:	inc	di		; next x tile
	jmp	DNNLoop
	

DownNewSlope:				;3 Have crossed into new tile, check if moved into slope
	mov	ax, [bp+new_box_bot_y_T]	; Get Tileinfo for midpoint_x tile, in new y coord tile
	mov	cx, [bp+midpoint_x_T]
	mov	dx, 0		; blocking up plane
	
	call	GetTileInfo
	
	test	al, 80h
	jz	MoveHorz

	mov	si, ax		; si = blocking up info
	xor	edx, edx
	mov	dx, [bp+new_box_bot_y_T]	
	shl	edx, 12		; edx = b_map
	mov	eax, [bp+midpoint_x]	; eax = x

	call	SlopeIntVert		;eax = y_int
	
	cmp	eax, [bp+old_box_bot_y]	; this must be false
	jle	MoveHorz		; 
	cmp	eax, temp_sprite.boxY2		; 
	jg	MoveHorz

	sub	eax, temp_sprite.boxY2		; corr = dest - src = y_int - y_new
	dec	eax		; make correction one more negative so it will be atop slope
	
	inc	word ptr [bp+bottomtile]	; +1 = on slope
	;jmp	AdjustYDown

AdjustYDown:	mov	word ptr temp_sprite.velY, 0
	add	temp_sprite.delY, ax					
	add	temp_sprite.boxY1, eax
	add	temp_sprite.boxY2, eax

	
	mov	eax, temp_sprite.boxY1		; update tiles for second Y checking
	shr	eax, 12
	mov	ax, [bp+box_top_y_T]
	mov	eax, temp_sprite.boxY2
	shr	eax, 12
	mov	ax, [bp+box_bot_y_T]


	mov	word ptr [bp+blockingreturn], 2					
	jmp	MoveHorz



MoveUp:				;1. Check if origin tile is slope block down
UpOldSlope:				; by determining intersection point of movement
				; with line of tile-slope
	
	mov	cx, [bp+midpoint_x_T]	;get tileinfo for  origin tile
	mov	ax, [bp+old_box_top_y_T]
	mov	dx, 2		;blocking down plane,
	call	GetTileInfo		;ax = info

	test	al, 80h		;bit7 = sloped bit
	jz	UpNewNormal		;if not then continue
	
	mov	si, ax
	xor	edx, edx
	mov	dx, [bp+old_box_top_y_T]	
	shl	edx, 12		;edx = b_map
	mov	eax, [bp+midpoint_x]

	call	SlopeIntVert
	
	cmp	eax, [bp+old_box_top_y]	; correct if y_int <=  y_old
	jg	MoveHorz		; (skip correction if greater)
	cmp	eax, temp_sprite.boxY1		; correct if y_int > y_new
	jle	MoveHorz		;
	
	sub	eax, temp_sprite.boxY1		; eax = y_int-y_new = correction factor
	add	eax, 4h		; test: give buffer		
	jmp	AdjustYUp		; apply corr

UpNewNormal:				;2 Check if crossing into new tile, and if it is normal blocking

	mov	ax, [bp+new_box_top_y_T]
	cmp	ax, [bp+old_box_top_y_T]
	je	MoveHorz		;If not crossing, then done and move to horz
	
	mov	di, [bp+box_left_x_T]

UNNLoop:				; loop through range of x coords representing tiles spanned by sprite 
	cmp	di, [bp+box_right_x_T]
	jg	UpNewSlope		; no blocking, have to check slope in new tile (step 3)
	
	mov	ax, [bp+new_box_top_y_T]	; get blocking down  for tile(x,new box top y)
	mov	cx, di
	mov	dx, 2		; block down plane
	
	call	GetTileInfo
	test	al, 80h
	jnz	UNNLoopC
	test	al, 3		; 01, 02, 03 are normal blocking 00 is not
	jz	UNNLoopC		; if tile == 0  then corect and tohorz
	
	xor	eax, eax
	mov	ax, [bp+old_box_top_y_T]	; dest = top of NEW_tile
	shl	eax, 12		; (in map units)
	
	sub	eax, temp_sprite.boxY1		; corr = dest - src
	jmp	AdjustYUp


UNNLoopC:	inc	di		; next x tile
	jmp	UNNLoop
		

					
UpNewSlope:				; 3 Have crossed into new tile, check if moved into slope
	mov	ax, [bp+new_box_top_y_T]	; Get Tileinfo for midpoint_x tile, in new y coord tile
	mov	cx, [bp+midpoint_x_T]
	mov	dx, 2		; 3 = blocking down
	
	call	GetTileInfo
	
	test	al, 80h
	jz	MoveHorz
	
	mov	si, ax
	xor	edx, edx
	mov	dx, [bp+new_box_top_y_T]	
	shl	edx, 12		; edx = b_map
	mov	eax, [bp+midpoint_x]	; x

	call	SlopeIntVert		; return: eax = y_int
	
	cmp	eax, [bp+old_box_top_y]	; correct if y_int <=  y_old
	jg	MoveHorz		; (skip correction if greater)
	cmp	eax, temp_sprite.boxY1		; correct if y_int > y_new
	jle	MoveHorz		;	
	 
	sub	eax, temp_sprite.boxY1		; corr = dest - src = y_int - y_new
	add	eax, 4h		; test: buffer
	
	
AdjustYUp:	mov	word ptr temp_sprite.velY, 0		; apply coorection factor to all
	add	temp_sprite.delY, ax					
	add	temp_sprite.boxY1, eax
	add	temp_sprite.boxY2, eax

	mov	eax, temp_sprite.boxY1		; update tiles for second Y checking
	shr	eax, 12
	mov	ax, [bp+box_top_y_T]
	mov	eax, temp_sprite.boxY2
	shr	eax, 12
	mov	ax, [bp+box_bot_y_T]
	
	mov	word ptr [bp+blockingreturn], 8					
	jmp	MoveHorz

;==============================================================================================================
; PART II - CORRECT X
;==============================================================================================================
	
MoveHorz:	
	; At this point, initial Y movement has been handled
	; Know whether or not contacted with slope or with normal
	; MoveHorz must check BOTH top and bottom midpoints for slope blocking
	; Midpoint_x renamed to old_midpoint_x at bp-26, tile at bp-28			
	
blockingreturn	=	-2
old_box_left_x	=	-6		;dword
old_box_left_x_T 	=	-8
new_box_left_x_T	=	-10
old_box_right_x	=	-14		; dword
old_box_right_x_T=	-16
new_box_right_x_T =	-18
box_top_y_T	=	-20
box_bot_y_T	=	-22
old_midpoint_x	=	-26		;dwords
old_midpoint_x_T	=	-28
new_midpoint_x	=	-32		;dword
new_midpoint_x_T =	-34
old_slope_corr	=	-38
normal_corr	=	-42
new_slope_corr	=	-46

	
	movsx	ebx, word ptr temp_sprite.delX	; temp_sprite.delX: change in map units
	
	mov	eax, temp_sprite.boxX1		; temp_sprite.boxX1 += temp_sprite.delX
	mov	[bp+old_box_left_x], eax
	mov	ecx, eax
	shr	ecx, 12
	mov	[bp+old_box_left_x_T], cx	;TILE(OLD temp_sprite.boxX1)
	add	eax, ebx              	          	
	mov	temp_sprite.boxX1, eax		; New Box Left_x                
	shr	eax, 12
	mov	[bp+new_box_left_x_T], ax	;TILE(NEW temp_sprite.boxX1)
	
	mov 	eax, temp_sprite.boxX2		; temp_sprite.boxX2 += temp_sprite.delX
	mov	[bp+old_box_right_x], eax
	mov	ecx, eax
	shr	ecx, 12
	mov	[bp+old_box_right_x_T], cx	;TILE(OLD temp_sprite.boxX2)
	add 	eax, ebx
	mov 	temp_sprite.boxX2, eax                
	shr	eax, 12
	mov	[bp+new_box_right_x_T], ax	;TILE(NEW temp_sprite.boxX2)

	mov	eax, [bp+old_midpoint_x]
	add	eax, ebx
	mov	[bp+new_midpoint_x], eax	;Apply temp_sprite.delX to midpoint
	shr	eax, 12
	mov	[bp+new_midpoint_x_T], ax

	mov	eax, temp_sprite.boxY1		 ;TILE(temp_sprite.boxY1)	
	shr	eax, 12			                
	mov	[bp+box_top_y_T], ax                    
	
	mov	eax, temp_sprite.boxY2		;TILE(temp_sprite.boxY2)              
	shr	eax, 12                         
	mov	[bp+box_bot_y_T], ax                                           
	
	xor	eax, eax
	mov	[bp+old_slope_corr], eax
	mov	[bp+normal_corr], eax
	mov	[bp+new_slope_corr], eax
	
	cmp 	bx, 0				            
	je	Done		;if temp_sprite.delY = 0, goto MOVE_HORZ                
	jl	MoveLeft		;if temp_sprite.delY<0, goto MOVE_UP move horz for now

MoveRight:

	
RightOldSlopeTop:	
	
	mov	cx, [bp+old_midpoint_x_T]	;get tileinfo for  origin tile
	mov	ax, [bp+box_top_y_T]
	mov	dx, 3		;slope info plane, (blocking left edge)
	call	GetTileInfo		;ax = info

	test	al, 80h		;bit7 = sloped bit
	jz	RightNewNormal		;if not sloped then check normal
	
	mov	si, ax
	xor	edx, edx
	mov	dx, [bp+old_midpoint_x_T]	
	shl	edx, 12		; edx = a_map
	mov	eax, temp_sprite.boxY1		; eax = point y

	call	SlopeIntHorz		; return x_int in eax
	
	cmp	eax, [bp+old_midpoint_x]	; correct if x_int >= old_mix
	jl	RightNewNormal		; (skip if not)
	cmp	eax, [bp+new_midpoint_x]	; correct if x_int < old_midx
	jge	RightNewNormal
	
	sub	eax, [bp+new_midpoint_x]	; eax = x_int-x_new = correction factor
	sub	eax, 080h 		; make it one more negative (set left of the line) -- test with large buffer
	mov	[bp+old_slope_corr], eax	;

RightNewNormal:			; 2 Check if crossing into new tile, and if it is normal blocking
				;  MUST ALWASY check (1) and (2)

	mov	ax, [bp+new_box_right_x_T]
	cmp	ax, [bp+old_box_right_x_T]	;If not crossing, then done and apply correction
	je	RightNewSlopeTop
	
	mov	di, [bp+box_bot_y_T]
	cmp	[bp+bottomtile], word ptr 1	; if slopeblocked, don't want to check the bottom most tile, because if going up slope
	jne	RNNLoop		; this will cause blocking 
	dec	di
	
RNNLoop:				; loop through range of x coords representing tiles spanned by sprite 
	cmp	di, [bp+box_top_y_T]
	jl	RightNewSlopeTop	; no blocking, have to check slope in new tile (step 3)
	
	mov	ax,di		; ax = tile_y
	mov	cx, [bp+new_box_right_x_T]	; cx = tile_x
	mov	dx, 3		; block left plane
	
	call	GetTileInfo
	test	al, 80h
	jnz	RNNLoopC
	test	ax, 3		; 01, 02, 03 are normal blocking 00 is not
	jz	RNNLoopC		; if tile != 0  then corect and tohorz
	
	mov	ax, word ptr temp_sprite.boxX2				
	inc	ax										
	and	ax, 0FFFh
	neg	ax
	cwde

	
	mov	[bp+normal_corr], eax
	jmp	RightCorrApply		;don't need to bother with final slope checking, wont' be going that far.

RNNLoopC:	dec	di		; next x tile
	jmp	RNNLoop
	

RightNewSlopeTop:
	
	mov	cx, [bp+new_midpoint_x_T]	;get tileinfo for  dest tile
	mov	ax, [bp+box_top_y_T]
	mov	dx, 3		;slope info plane, (should be blocking left edge)
	call	GetTileInfo		;ax = info

	test	al, 80h		;bit7 = sloped bit
	jz	RightCorrApply		;if not then continue
	
	mov	si, ax
	xor	edx, edx
	mov	dx, [bp+new_midpoint_x_T]	
	shl	edx, 12		;edx = a_map
	mov	eax, temp_sprite.boxY1		;eax = y_map

	call	SlopeIntHorz		; return x_int in eax
	
	cmp	eax, [bp+old_midpoint_x]	; correct if x_int >= old_mix
	jl	rnst1		; (skip if not)
	cmp	eax, [bp+new_midpoint_x]	; correct if x_int < old_midx
	jge	rnst1
	
	sub	eax, [bp+new_midpoint_x]	; eax = x_int-x_new = correction factor
	sub	eax, 080h		; make eax one more negative -- test large buffer
	mov	[bp+old_slope_corr], eax	
rnst1:	jmp	RightCorrApply

RightCorrApply:	
	mov	eax, [bp+old_slope_corr]	;eax holds max value
	cmp	eax, [bp+normal_corr]	;if normal is LESS NEGATIVE (bigger)
	jl	rca1		;then DON'T REPLACE
	mov	eax, [bp+normal_corr]
rca1:	cmp	eax, [bp+new_slope_corr]
	jl	rca2
	mov	eax, [bp+new_slope_corr]
rca2:	or	eax, eax		; if correction is zero, don't apply it/  set blocking, 
	jz	rca3		; and continue on to check ground slope
	mov	word ptr temp_sprite.velX, 0		; If correction != 0, then apply
	add	temp_sprite.delX, ax					
	add	temp_sprite.boxX1, eax
	add	temp_sprite.boxX2, eax
	add	[bp+new_midpoint_x], eax
	mov	eax, [bp+new_midpoint_x]
	shr	eax, 12
	mov	ax, [bp+new_midpoint_x_T]
	or	word ptr [bp+blockingreturn], 4					
rca3:	jmp	ReCheckY		; Now All X correction is done, all that remains is Y-correction due to sloped bottom 	

MoveLeft:
LeftOldSlopeTop:	
	
	mov	cx, [bp+old_midpoint_x_T]	;get tileinfo for  origin tile
	mov	ax, [bp+box_top_y_T]
	mov	dx, 1		;slope info plane, (blocking right edge)
	call	GetTileInfo		;ax = info

	test	al, 80h		;bit7 = sloped bit
	jz	LeftNewNormal		;if not sloped then check normal
	
	mov	si, ax
	xor	edx, edx
	mov	dx, [bp+old_midpoint_x_T]	
	shl	edx, 12		; edx = a_map
	mov	eax, temp_sprite.boxY1		; eax = point y

	call	SlopeIntHorz		; return x_int in eax
	
	cmp	eax, [bp+old_midpoint_x]	; correct if x_int < old_midx AND
	jg	LeftNewNormal		; (skip if not)
	cmp	eax, [bp+new_midpoint_x]	; correct if x_int > old_midx
	jl	LeftNewNormal
	
	sub	eax, [bp+new_midpoint_x]	; eax = x_int-x_new = correction factor
	add	eax, 080h 		; set it right of slope -- test with large buffer
	mov	[bp+old_slope_corr], eax	;

LeftNewNormal:				; 2 Check if crossing into new tile, and if it is normal blocking
				;  MUST ALWASY check (1) and (2)

	mov	ax, [bp+new_box_left_x_T]
	cmp	ax, [bp+old_box_left_x_T]	;If not crossing, then check if MIDPOINT crosses
	je	LeftNewSlopeTop
	
	mov	di, [bp+box_bot_y_T]
	cmp	[bp+bottomtile], word ptr 1	; if slopeblocked ground, don't want to check the bottom most tile, because if going up slope
	jne	LNNLoop		; this will cause blocking 
	dec	di

LNNLoop:				; loop through range of x coords representing tiles spanned by sprite 
	cmp	di, [bp+box_top_y_T]
	jl	LeftNewSlopeTop	; no blocking, have to check slope in new tile (step 3)
	
	mov	ax,di		; ax = tile_y
	mov	cx, [bp+new_box_left_x_T]	; cx = tile_x
	mov	dx, 1		; block right plane
	
	call	GetTileInfo
	test	al, 80h
	jnz	LNNLoopC
	test	ax, 3		; 01, 02, 03 are normal blocking 00 is not
	jz	LNNLoopC		; if tile != 0  then corect and tohorz
	
	xor	eax, eax
	mov	ax, [bp+old_box_left_x_T]	; dest = left edge of new tile of NEW_tile
	shl	eax, 12		; (in map units)
	
	sub	eax, temp_sprite.boxX1		; corr = dest - src
	

	mov	[bp+normal_corr], eax
	jmp	LeftCorrApply		;don't need to bother with final slope checking, wont' be going that far.

LNNLoopC:	dec	di		; next x tile
	jmp	LNNLoop
	

LeftNewSlopeTop:
	
	mov	cx, [bp+new_midpoint_x_T]	;get tileinfo for  dest tile
	mov	ax, [bp+box_top_y_T]
	mov	dx, 1		;slope info plane, (should be blocking right edge)
	call	GetTileInfo		;ax = info

	test	al, 80h		;bit7 = sloped bit
	jz	LeftCorrApply		;if not then continue
	
	mov	si, ax
	xor	edx, edx
	mov	dx, [bp+new_midpoint_x_T]	
	shl	edx, 12		;edx = a_map
	mov	eax, temp_sprite.boxY1		;eax = y_map

	call	SlopeIntHorz		; return x_int in eax
	
	cmp	eax, [bp+old_midpoint_x]	; correct if x_int < old_midx AND
	jg	lnst1		; (skip if not)
	cmp	eax, [bp+new_midpoint_x]	; correct if x_int > old_midx
	jl	lnst1
	
	sub	eax, [bp+new_midpoint_x]	; eax = x_int-x_new = correction factor
	add	eax, 080h		; set right of line -- test large buffer
	mov	[bp+old_slope_corr], eax	
lnst1:	jmp	LeftCorrApply

LeftCorrApply:	
	mov	eax, [bp+old_slope_corr]	;eax holds max value
	cmp	eax, [bp+normal_corr]	;if normal is LESS NEGATIVE (bigger)
	jg	lca1		;then DON'T REPLACE
	mov	eax, [bp+normal_corr]
lca1:	cmp	eax, [bp+new_slope_corr]
	jg	lca2
	mov	eax, [bp+new_slope_corr]
lca2:	or	eax, eax		; if correction is zero, don't apply it/  set blocking, 
	jz	lca3		; and continue on to check ground slope
	mov	word ptr temp_sprite.velX, 0		; If correction != 0, then apply
	add	temp_sprite.delX, ax					
	add	temp_sprite.boxX1, eax
	add	temp_sprite.boxX2, eax
	add	[bp+new_midpoint_x], eax
	mov	eax, [bp+new_midpoint_x]
	shr	eax, 12
	mov	ax, [bp+new_midpoint_x_T]
	or	word ptr [bp+blockingreturn], 1					
lca3:	;jmp	ReCheckY		; All x correction is finished all that remains is Y-correction due to sloped bottom	


;==============================================================================================================
;PART III - RECHECK Y
;==============================================================================================================



ReCheckY:	

	; After this, no more X correction because it has been handled
	; no sprite can contact top and bottom slopes at once (by level design rules)

	; If on positive slope and at leftmost edge of tile (midpoint mod 1000h < 10h), 
	; sprite can be on top of the slope tile; therefore box_bot_T will not give the appropriate results
	
	; To fix this, if standing on SlopeBottom and box_bot_y_T not sloped, inc box bot y t
	
	mov	eax, [bp+old_midpoint_x]	; if not next to left edge, no fix
	and	ax, 0FFFh
	cmp	ax, 10h
	jg	rcy1
	
	cmp	word ptr [bp+bottomtile], 1	; if not slope-grounded from part 1, no fix
	jne	rcy1
	
	xor	dx, dx		; dx = top plane
	mov	cx, [bp+old_midpoint_x_T]	; cx = tile_x
	mov	ax, [bp+box_bot_y_T]	; ax = tile_y,
	call	GetTileInfo		
	
	bt	ax, 7		; if bot_Y_T is not sloped, do fix
	jc	rcy1
	
	inc	word ptr [bp+box_bot_y_T]
	
	

rcy1:	mov	ax, [bp+old_midpoint_x_T]
	cmp	ax, [bp+new_midpoint_x_T]
	jne	NewSlopeBot
	
OldSlopeBot:				; DEST X TILE = SRC X TILE
	cmp	word ptr [bp+bottomtile], 0	; 
	jl	DONE		; -1 if on normal bottom --> no corrections
	je	OldSlopeBotNot		; 0 if not on bottom, must check interception of movmemnt
				; +1 if on slope bottom --> y correction
	xor	dx, dx		
	mov	cx, [bp+new_midpoint_x_T]	; get slope info of blocking top edge (know it is sloped) 
	mov	ax, [bp+box_bot_y_T]
	call	GetTileInfo
	mov	si, ax
	
	jmp	OSBYCorr		; si contains slope info, jump to Correction Code

OldSlopeBotNot:	mov	cx, [bp+new_midpoint_x_T]
	mov	ax, [bp+box_bot_y_T]	; if zero, then must check if x crosses with slope 
	xor	dx, dx		; dx = opposing slope plane 
	call	GetTileInfo		; ax = tile_y, cx = tile_x

	mov	si, ax		; si holds info
	
	test	al, 80h		; if sloped
	jz	Done		; if not sloped remaining in same tile, then no y corrections needed
	
	xor	edx, edx		; now, check if temp_sprite.delX brings midpoint_x underneath slope
	mov	dx, [bp+new_midpoint_x_T]
	shl	edx, 12		; edx = a_map
	mov	eax, temp_sprite.boxY2		; eax = point_y
	call	SlopeIntHorz		;return x_int in eax --> now check intercept, if intercept correct
				; otherwise Done

	; test - don't correct if moving "out of" a JUMP  FROM BENEATH slope bottom 
	; (ie moving right into positive slope, vice versa)
OSBNJFB:	xor	bx, bx
	bt	si, 6		; si = old tile top blocking; bit 6 = slope direction;
	rcl	bl, 1		; put bit 6 into bl bit 0
	mov	cx, temp_sprite.delX
	bt	cx, 15		; put sign bit of velocity into carry
	rcl	bh, 1		; into bh bit 0
	cmp	bh, bl		; if bit 0 bh = bl (zero flag set), then moving out from under slope
	je	Done		; so don't correct movement
	
	; Passed above test, so sprite is moving into the slope face (not out from underneath)
	; Thus, if it crosses the slope plane,  correct it
	
	cmp	word ptr temp_sprite.delX, 0
	jl	OSBNL		; moving left, switch signs
	
OSBNR:	cmp	eax, [bp+old_midpoint_x]	; eax = x_int
	jl	Done
	cmp	eax, [bp+new_midpoint_x]
	jg	Done
	jmp	OSBYCorr
	
OSBNL:	cmp	eax, [bp+old_midpoint_x]	; eax = x_int
	jg	Done
	cmp	eax, [bp+new_midpoint_x]
	jl	Done
	;jmp	OSBYCorr

OSBYCorr:
	xor	edx, edx		; (si = end tile info)
	mov	dx, [bp+box_bot_y_T]	
	shl	edx, 12		; edx = b_bmp
	mov	eax, [bp+new_midpoint_x]	; eax = dest, 
	
	call	SlopeIntVert		; return: eax = y_int
	
	sub	eax, temp_sprite.boxY2		; corr = dest-src = y_int - temp_sprite.boxY2
	dec	eax 		; buffer (set atop slope)

	add	temp_sprite.delY, ax					
	add	temp_sprite.boxY1, eax
	add	temp_sprite.boxY2, eax

	or	word ptr [bp+blockingreturn], 2
	jmp	Done

NewSlopeBot:				; DEST X TILE != SRC X TILE
				; (midpoint x crossing into new tile)
	cmp	word ptr [bp+bottomtile], 0
	jg	NSBSlope		; +1 = slope-grounded: check if moving up slope or down slope
	jl	NSBNormal		; - 1 = normal-grounded\
	

NewSlopeNotGrd:			; 0= not grounded
	; must check both new and old tiles for bottom slopes,  first check old, then check new
	; check both slopes in opposing blocking plane. If either slope intersects movement, resolve as up blocking
	
	mov	cx, [bp+old_midpoint_x_T]	; get starting tile info
	mov	ax, [bp+box_bot_y_T]
	xor	dx, dx
	call	GetTileInfo
	
	mov	si, ax
	test	al, 80h
	jz	OldSlopeBotNot		; if old tile not sloped, check new tile (using oldslopebot code)
				; else old tile is sloped, 
	
	xor	edx, edx		; now, check if temp_sprite.delX brings midpoint_x underneath slope
	mov	dx, [bp+old_midpoint_x_T]
	shl	edx, 12		; edx = a_map
	mov	eax, temp_sprite.boxY2		; eax = point_y
	call	SlopeIntHorz		; return x_int in eax --> now check intercept
				; if movement intercepts slope, resolve as leaving an UP slope (NSBUp)
				; if movement doesn't intercept slope, check new tile (using oldslopebot code)
	
	;if moving out from underneath a jump from beneath slope", DO NOT want to correct slope
	; (preserve AX for NSNGR/L)
NSNGJFB:	xor	bx, bx
	bt	si, 6		; si = old tile top blocking; bit 6 = slope direction;
	rcl	bl, 1		; put bit 6 into bl bit 0
	mov	cx, temp_sprite.delX
	bt	cx, 15		; put sign bit of velocity into carry
	rcl	bh, 1		; into bh bit 0
	cmp	bh, bl		; if bit 0 bh = bl (zero flag set), then moving out from under slope
	je	Done		; so don't correct movement
	
	; Passed above test, so sprite is moving into the slope face (not out from underneath)
	; Thus, if it crosses the slope plane, I want to correct
	cmp	word ptr temp_sprite.delX, 0
	jl	NSNGL		; moving left, switch signs
	
NSNGR:	cmp	eax, [bp+old_midpoint_x]	; eax = x_int
	jl	OldSlopeBotNot
	cmp	eax, [bp+new_midpoint_x]
	jg	OldSlopeBotNot
	jmp	NSBUp
	
NSNGL:	cmp	eax, [bp+old_midpoint_x]	; eax = x_int
	jg	OldSlopeBotNot
	cmp	eax, [bp+new_midpoint_x]
	jl	OldSlopeBotNot
	jmp	NSBUp

NSBSlope:	
	; Sprite is on a slope moving out of tile
	; Determining if moving Up or Down a slope --> multiply slope sign (m) of current midpoint tile by temp_sprite.delX
	; if positive product, moving Down; if negative product, Moving up
	
	mov	ax, [bp+box_bot_y_T]
	mov	cx, [bp+old_midpoint_x_T]
	xor 	dx, dx		; get blocking up info for starting tile
				; (if slope-grounded, then we must be on a slope currently)
	call	GetTileInfo
	
	mov	bx, temp_sprite.delX
	bt	ax, 6		; 6 = sign bit
	jnc	nsb1
	neg	bx		; if m negative, flip 	
nsb1:	cmp	bx, 0
	jg	NSBDown
	;jmp	NSBUp
	
	
NSBUp:				; moving up		
	
nbsu1:	mov	ax, [bp+box_bot_y_T]	; 1) Check dest_y for  slope.  If slope, set there
	mov	cx, [bp+new_midpoint_x_T]
	xor	dx, dx
	
	call	GetTileInfo
	
	test	al, 80h		; if not slope, move on
	jz	nsbu2
	
	mov	si, ax		; if slope, set top slope
	xor	edx, edx		; edx = b_map
	mov	dx, [bp+box_bot_y_T]
	shl	edx, 12
	mov	eax, [bp+new_midpoint_x]	; eax = point_x
	
	call	SlopeIntVert
	
	sub	eax, temp_sprite.boxY2		; corr = dest-src = y_int - temp_sprite.boxY2
	dec	eax		; make more negative (buffersize) to set atop line
	
	jmp	NSBYCorr
	
	
nsbu2:	mov	ax, [bp+box_bot_y_T]	; 2) Check dest_y for normal  If normal set there
	mov	cx, [bp+new_midpoint_x_T]
	xor	dx, dx		; plane = top face
	
	call	GetTileInfo		
	
	test	al, 80h		; if slope, skip normal correction
	jnz	nbsu3
	test	al, 3
	jz	nbsu3		; if not blocking, move on
	 
	
	mov	ax, word ptr temp_sprite.boxY2		; y correction, atop of dest_y				
	inc	ax
	and	ax, 0FFFh
	neg	ax
	cwde
	
	jmp	NSBYCorr
 
	
nbsu3:	mov	ax, [bp+box_bot_y_T]	; 3) Check dest_y - 1 for uphill slope
	dec	ax
	mov	cx, [bp+new_midpoint_x_T]
	xor	dx, dx		; plane = opposing face	
	
	call	GetTileInfo
	
	test	al, 80h
	jz	nbsu4		; if not slope move on
	
	mov	si, ax		; if slope, set top slope
	xor	edx, edx		; edx = b_map
	mov	dx, [bp+box_bot_y_T]
	dec	dx
	shl	edx, 12
	mov	eax, [bp+new_midpoint_x]	; eax = point_x
	
	call	SlopeIntVert
	
	sub	eax, temp_sprite.boxY2		; corr = dest-src = y_int - temp_sprite.boxY2
	dec	eax		; make more negative (buffersize) to set atop line
	
	jmp	NSBYCorr
	

nbsu4:	mov	ax, word ptr temp_sprite.boxY2		; y correction, atop of dest_y				
	inc	ax
	and	ax, 0FFFh
	neg	ax
	cwde
	
	jmp	NSBYCorr
	

NSBNormal:				; slope-grounded and moving out of the tile, travelling acrros or down
	

nbsn1:	mov	ax, [bp+box_bot_y_T]	; 1) check desty + 1 for slope
	inc	ax
	mov	cx, [bp+new_midpoint_x_T]
	xor	dx, dx	
	
	call	GetTileInfo
	
	test	al, 80h
	jz	nbsn2
	
	mov	si, ax		; if slope, set top slope
	xor	edx, edx		; edx = b_map
	mov	dx, [bp+box_bot_y_T]
	inc	dx
	shl	edx, 12
	mov	eax, [bp+new_midpoint_x]	; eax = point_x
	
	call	SlopeIntVert
	
	sub	eax, temp_sprite.boxY2		; corr = dest-src = y_int - temp_sprite.boxY2
	dec	eax		; make more negative (buffersize) to set atop line
	
	jmp	NSBYCorr	


	
nbsn2:	mov	ax, [bp+box_bot_y_T]	; 2) if desty+1 is normal, set there (movement across)
	inc	ax
	mov	cx, [bp+new_midpoint_x_T]
	xor 	dx, dx		; plane = top slope
	
	call	GetTileInfo
	
	test	al, 80h
	jnz	nbsn3		; if slope, skip normal correction
	test	al, 3	; if blocking skip normal coorection
	jz	nbsn3
	
	mov	eax, temp_sprite.boxY2		; make a normal correction, 
	or	eax, 0FFFh
	
	sub	eax, temp_sprite.boxY2		; corr = dest - src = bottom of current tile - temp_sprite.boxY2
	
	jmp	NSBYCorr

nbsn3:	mov	ax, [bp+box_bot_y_T]	; 3) if dest_y is slope, set there (movement across to start of uphill)
	mov	cx, [bp+new_midpoint_x_T]
	xor	dx, dx
	call	GetTileInfo
	
	test	al, 80h
	jz	nbsn4
	
	mov	si, ax		; if slope, set top slope
	xor	edx, edx		; edx = b_map
	mov	dx, [bp+box_bot_y_T]
	shl	edx, 12
	mov	eax, [bp+new_midpoint_x]	; eax = point_x
	
	call	SlopeIntVert
	
	sub	eax, temp_sprite.boxY2		; corr = dest-src = y_int - temp_sprite.boxY2
	dec	eax		; make more negative (buffersize) to set atop line
	
	jmp	NSBYCorr

	
nbsn4:	mov	eax, temp_sprite.boxY2		; make a normal correction to the bottom of this tile
	or	eax, 0FFFh		; (ie set y to normal dest_y + 1)
	
	sub	eax, temp_sprite.boxY2		; corr = dest - src = bottom of current tile - temp_sprite.boxY2
	
	;jmp	NSBYCorr		


NSBDown:				; slope-grounded and moving out of the tile, travelling acrros or down
	
	
	
nbsd1:	mov	ax, [bp+box_bot_y_T]	; 3) if dest_y is slope, set there (movement across to start of uphill)
	mov	cx, [bp+new_midpoint_x_T]
	xor	dx, dx
	call	GetTileInfo
	
	test	al, 80h
	jz	nbsd2
	
	mov	si, ax		; if slope, set top slope
	xor	edx, edx		; edx = b_map
	mov	dx, [bp+box_bot_y_T]
	shl	edx, 12
	mov	eax, [bp+new_midpoint_x]	; eax = point_x
	
	call	SlopeIntVert
	
	sub	eax, temp_sprite.boxY2		; corr = dest-src = y_int - temp_sprite.boxY2
	dec	eax		; make more negative (buffersize) to set atop line
	
	jmp	NSBYCorr


	
nbsd2:	mov	ax, [bp+box_bot_y_T]	; 2) if desty+1 is normal, set there (movement across)
	inc	ax
	mov	cx, [bp+new_midpoint_x_T]
	xor 	dx, dx		; plane = top slope
	
	call	GetTileInfo
	
	test	al, 80h
	jnz	nbsd3		; if slope, skip normal correction
	test	al, 3
	jz	nbsd3
	
	mov	eax, temp_sprite.boxY2		; make a normal correction, 
	or	eax, 0FFFh
	
	sub	eax, temp_sprite.boxY2		; corr = dest - src = bottom of current tile - temp_sprite.boxY2
	
	jmp	NSBYCorr



nbsd3:	mov	ax, [bp+box_bot_y_T]	; 1) check desty + 1 for slope
	inc	ax
	mov	cx, [bp+new_midpoint_x_T]
	xor	dx, dx	
	
	call	GetTileInfo
	
	test	al, 80h
	jz	nbsd4
	
	mov	si, ax		; if slope, set top slope
	xor	edx, edx		; edx = b_map
	mov	dx, [bp+box_bot_y_T]
	inc	dx
	shl	edx, 12
	mov	eax, [bp+new_midpoint_x]	; eax = point_x
	
	call	SlopeIntVert
	
	sub	eax, temp_sprite.boxY2		; corr = dest-src = y_int - temp_sprite.boxY2
	dec	eax		; make more negative (buffersize) to set atop line
	
	jmp	NSBYCorr
	

	
nbsd4:	mov	eax, temp_sprite.boxY2		; make a normal correction to the bottom of this tile
	or	eax, 0FFFh		; (ie set y to normal dest_y + 1)
	
	sub	eax, temp_sprite.boxY2		; corr = dest - src = bottom of current tile - temp_sprite.boxY2
	
	;jmp	NSBYCorr		
		
	
NSBYCorr:	;mov	word ptr temp_sprite.velY, 0		; standard y correction
	add	temp_sprite.delY, ax					
	add	temp_sprite.boxY1, eax
	add	temp_sprite.boxY2, eax

	or	word ptr [bp+blockingreturn], 2
	;jmp	Done
	

Done:	mov	ax, [bp+blockingreturn]
	pop	di
	pop	si
	mov	sp, bp
	pop	bp

	retf
CM_check_ground 	ENDP


SlopeIntVert	PROC	Near
	; Of the sprite:	Given map point x 
	; Of the tile:      	Given offset in map units to top of tile (bmap) and slope blocking info
	; Returns the Y map coordinate  of y-intercept on tile slope (assumes tile is sloped), 
	
	; entry	si = blocking info
	;	eax = x
	;	edx = bmap

	; returns	eax =y_int
	
	
GetSlope:	mov	cx, si		; get value of m
	and	cl, 30h		; bits 5 and 6
	shr	cl, 4		; |m| = value of slope = 2 ^ ( - cl)		

GetDisp:	xor	ebx, ebx
	mov	bx, si		; get disp (b_tile)
	and	bx, 0Ch		; bl = (b_tile) IN PIXELS

SlopeTest:	and	eax, 0FFFh		; eax = mid_x midpoint_x MOD 1000h ==> x coord in tile
	
	bt	si, 6		; sign of m = bit six; - if set, + if not
	jnc	Ahead		; if not negative, then continue
	
NegSlope:	add	bl, 4		; add 4 to b_tile if m is negative (as per specs)
	neg	eax		; flip sign of m
	
Ahead:	sar	eax, cl		; eax = m*(mid_x) 
	shl	ebx, 8		; ebx = b_tile in 256ths of PIXELS (map units)
	add	eax, ebx		; eax = m*(mid_x) + b_tile
	add	eax, edx		; eax = m*(mid_x) + b_tile + b_map = y_int
	ret
	
SlopeIntVert 	ENDP

SlopeIntHorz	PROC	Near

	; Of the sprite:	Given map point y 
	; Of the tile:      	Given offset in map units to top of tile (bmap) and slope blocking info
	; Returns the X map coordinate (x_int)  of intercept of point_y on tile slope (assumes tile is sloped), 
	
	; entry	si = blocking info
	;	eax = map point_y
	;	edx = amap (x displacement to left edge of map tile)

	; returns	eax =x_int
	
	
GetSlope:	mov	cx, si		; get value of m
	and	cl, 30h		; bits 5 and 6
	shr	cl, 4		; |m| = value of slope = 2 ^ ( - cl)		

GetDisp:	xor	ebx, ebx
	mov	bx, si		; get disp (b_tile)
	and	bx, 0Ch		; bl = (b_tile) IN PIXELS

SlopeTest:	and	eax, 0FFFh		; eax = point_y MOD 1000h ==> y_tile
	
	bt	si, 6		; sign of m = bit six; - if set, + if not
	jnc	Ahead		; if not negative, then continue
	
NegSlope:	add	bl, 4		; add 4 to b_tile if m is negative (as per specs)

Ahead:	shl	ebx, 8		; ebx = b_tile in 256ths of PIXELS
	sub	eax, ebx		; eax = y_tile - b_tile

	bt	si, 6
	jnc	Ahead2
	neg	eax		; swap sign if m is negative 

Ahead2:	sal	eax, cl		; eax =  (y_tile - b_tile) / m	
	add	eax, edx		; eax = (y_tile - b_tile) / m+ a_map = x_int
	ret

SlopeIntHorz	 ENDP

GetTileInfo	PROC	Near
;get_tile_info(cx tile_x, ax tile_y, dx plane_num) input x, y map_tile coords, returns returns tile_ID in ax For the New Patch
;0 = up
;1 = right
;2 = down
;3 = left
	imul	ax, map_width_T		;ax = (tile_y * mapwidth) + tile_x	
	add	ax, cx		;			
	shl	ax, 1		;convert to word	
	les	bx, map_data_tiles		;point es:bx to level map tile_data	
	add	bx, ax		;point es:bx to tile specified by ax	
	mov	ax, es:[bx]		;load ax with tile_number for tile specified by ax		
	imul	dx, 910		;dx = planenum * plane size	
GetInfo:	add	dx, ax		;dx = offset to tileinfo
	mov	bx, dx	 	;ds:dx points to tileinfo
	mov 	al, [bx+TI_UEDGE] 		;4138h = offset to blocking up start
	xor	ah,ah		; return tileinfo in al (ah is zero)
	ret
	
GetTileInfo 	ENDP


ORG 1000h
;===================================ADAPTIVE TILEREFRESH=======================
; On entry
; bp = anim_frame plane
; es:bx = upper left map tile to display (far pointer to map data tiles)
; ds = ss = dseg

; Registers:
; ax = column counter
; es:bx = pointer to current map tile
; cx = screen offset
; edx = ATR index
; si = 
; di = 
; bp = anim_frame plane
; ds = dseg

atrp_0	proc far

rowinit:
	shl ebx, 16
	shr ebx, 16
	mov cx, 604h
	xor edx, edx
	
rowcheck:
	cmp cx, 2E00h
	jge rowend
	
rowloop:

; Tile Loop: Go across 21 tile row
tileinit:
	xor ax, ax

tilecheck:
	cmp ax, 15h
	jge tileend

tileloop:
	mov si, es:[ebx+edx]						; compare es:bx to ATR_0[tile]
	shl si, 1							; 
	mov	si, [bp+si]						; si = tilenum for current anim
	cmp si, ATR_0[edx]					; if tilenum to draw == existing tile
	jz tileinc							; don't draw it
	mov ATR_0[edx], si					; else update ATR array and draw it
	mov di, cx
	call draw_tile_p
	
tileinc:
	inc ax

	inc cx
	inc cx
	
	inc edx
	inc edx
	
	jmp tilecheck

tileend:
	
rowinc:
	add bx, screen_wrap
	add cx, 2D6h
	jmp rowcheck

rowend:
	retf
atrp_0	endp

atrp_1	proc far

rowinit:
	shl ebx, 16
	shr ebx, 16
	mov cx, 604h
	xor edx, edx
	
rowcheck:
	cmp cx, 2E00h
	jge rowend
	
rowloop:

; Tile Loop: Go across 21 tile row
tileinit:
	xor ax, ax

tilecheck:
	cmp ax, 15h
	jge tileend

tileloop:
	mov si, es:[ebx+edx]						; compare es:bx to ATR_0[tile]
	shl si, 1							; 
	mov	si, [bp+si]						; si = tilenum for current anim
	cmp si, ATR_1[edx]					; if tilenum to draw == existing tile
	jz tileinc							; don't draw it
	mov ATR_1[edx], si					; else update ATR array and draw it
	mov di, cx
	call draw_tile_p
	
tileinc:

	inc ax

	inc cx
	inc cx
	
	inc edx
	inc edx
	
	jmp tilecheck

tileend:
	
rowinc:
	add bx, screen_wrap
	add cx, 2D6h
	jmp rowcheck

rowend:
	retf
atrp_1	endp

; on entry
; si = offset in tile gfx segment (display mem)
; di = offset in display page (display mem)

draw_tile_p	proc near
	push	es
	push	ds
	push	ax
	
	mov	es, page_current_seg					; es:di = start of tile in display page
	mov	ds, word ptr (tile_gfx + 2)		; ds:si = start of tile in gfx mem .. 
	mov	ax, 2Eh									; row is 30h bytes, row - tile = 2Eh
              	
    REPEAT	16		; 16 scan line per tile
	movsb
	movsb
	add	di, ax            
    ENDM
	
    pop ax
	pop	ds
	pop	es
	retn
draw_tile_p	endp




ATRSEG	ENDS


dseg	SEGMENT	PARA USE16
		INCLUDE <.\..\include\k1dseg.asm>
dseg	ENDS

sseg	SEGMENT	PARA USE16 STACK
sseg	ENDS

	END	start
