/* binpatch
 * commandline: binpatch <infile> <outfile> start stop
 * Creates outfile, which contains the bytes start to stop (inclusive) of infile
*/

#include <stdio.h>
#include <stdlib.h>

char *infile;
char *outfile;
int start, stop;
FILE *infile_fp, *outfile_fp;

int main(int argc, char* argv[]) {

	char *buf;
	int i, n;


	// get arguments
	if (argc <= 4) {
		printf("Args: %d \n Not enough args.\n\n", argc);
		exit(-1);
	}

/*
	for(i = 0; i < argc; i++) {
		printf("argv[%d]: %s \n", i, argv[i]);
	}
*/

	infile = argv[1];
	outfile = argv[2];
	if (sscanf(argv[3], "%i", &start) && sscanf(argv[4], "%i", &stop)) {
		n = stop - start + 1;
	} else {
		printf("Start, stop args not valid");
		exit(-1);
	}
	

	printf("Infile: %s \n" 
			"Outfile: %s \n"
			"start: %d \n"
			"stop: %d \n\n",
			infile, outfile, start, stop);

	infile_fp = outfile_fp = NULL;

	// Open files
	if ((infile_fp = fopen(infile, "rb")) == NULL) {
		printf("Cannot open input file: %s\n\n", infile);
		exit(-1);
	}

	if ((outfile_fp = fopen(outfile, "wb")) == NULL) {
		printf("Cannot open output file: %s\n\n", outfile);
		exit(-1);
	}

	if (fseek(infile_fp, stop, SEEK_SET) || fseek(infile_fp, start, SEEK_SET)) {
		printf("Input file does not span requested range: %X to %X", start, stop);
		exit(-1);
	}

	fseek(infile_fp, start, SEEK_SET);
	buf = (char*)malloc(n);

	fread(buf, 1, n, infile_fp);
	fwrite(buf, 1, n, outfile_fp);

	fclose(infile_fp);
	fclose(outfile_fp);

	free(buf);

	return 0;
}


